/*
 * Name     : QbGetImage.cpp
 * Author   : Xiaoming Zhu
 * Purpose  : Example for image IO Using QbGenericImageDataClass
 */

#include "QbImgDat.hpp"
int main( int argc, char **argv, char **envp ) {
  unsigned char *lut, *img, *mask, pix;
  unsigned long xlen, ylen, xp, yp;
  QbGenericImageDataClass   image;

  if ( argc < 2 ) {
      printf("usage %s foo.jpg [or foo.gif]\n");
      return -1;
  }

  image.ReadImageDataFromFile(argv[1]);
  lut = image.GetLut();
  img = image.GetImage();
  mask = image.GetMask();
  xlen = image.GetXsize();
  ylen = image.GetYsize();
  xp = xlen >> 1;
  yp = ylen >> 1;

  pix = img[yp * xlen + xp];

  printf("Image size x=%d y=%d\n", xlen, ylen);
  printf("pixel value at (%d, %d) R=%d G=%d B=%d\n", 
        xp, yp, lut[pix], lut[pix+256], lut[pix+512]);
  return 0;
}
