/*
 * Name     : QbKeyDis.cpp
 * Author   : Xiaoming Zhu
 * Purpose  : Calculate the distance between two input images
 *
 */
#include "QbAbsCls.hpp"
#include "QbImgDat.hpp"
#include "QbCreate.hpp"
//#include "QbQueryC.hpp"
//#include "QbQueryS.hpp"
#include <limits.h>
#include <float.h>

int main(int argc, char **argv)
{
  QbFeatureClass           *Feature1, *Feature2;
  QbGenericImageDataClass  Image;
  char                     *img1="../../html/images/ibm33/flower01.jpg";
  char                     *img2="../../html/images/ibm33/flower02.jpg";
  double                   distance;

  // create QbColorHistogramFeatureClass objects
  Feature1 = QbCreateFeatureClass( "QbColorHistogramFeatureClass" ) ;
  // Read images from file into QbGenericImageDataClass objects:
  Image.ReadImageDataFromFile( img1) ;
  // Compute feature data
  Feature1->ComputeFeature(&Image, Feature1->GetDefaultParameters());


  Feature2 = QbCreateFeatureClass( "QbColorHistogramFeatureClass" ) ;
  Image.ReadImageDataFromFile( img2 ) ;
  Feature2->ComputeFeature(&Image, Feature2->GetDefaultParameters());

  // Calculate the distance between two images
  distance = Feature1->Distance(Feature2, Feature1->GetDefaultParameters(),
             FLT_MAX);

  // Print results
  printf("Distance between %s and %s in Color Histogram =%lf\n",
          img1, img2, distance);

  // Clean up
  delete Feature1;
  delete Feature2;

  return 0;
}
