/*
 *  
 *  Licensed Materials - Property of IBM
 *
 *  (C) COPYRIGHT IBM Corp. 1994-1998 All rights reserved
 *
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * Filename : 53
 * Date     : 3/24/98 09:59:27
 * Version  : 1.1.1.3
 * Author   : automatic prototype generation
 * Purpose  : QBIC Utility Program
 *
 */

/* End of Common Block                                               */

#ifndef __QbInp_h
#define __QbInp_h
#if __STDC__ || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif
#ifndef __qmDraw_h
 typedef enum { IMG_GREY, IMG_COLOR, IMG_BINARY } QbImageType;
#endif
/* findfile.c */
extern int findfile P_((
	int control,
	const char *PathRef,
	const char *FileName,
	char *ResultBuffer,
	int ResultBufferLen
	));
/* QbAnyread.c */
extern
void QbAnyread P_((Impretc *rc,            /* return code                   */
                   const char *imagePathEV,/* environment variable giving
                                             paths to search for the image  */
                   const char *filename,   /* filename of the image to read */
                   Impvaru **imageread,    /* image read                    */
                   Impvaru **lutread,      /* lut read                      */
                   QbImageType *imageType, /* the type of image read        */
                   char    *imageDescription,/* text describing image       */
                   int     *maxDescriptionLength /* max (on input) and actual
                                             (on output) description length */
                   ));
/* QbAnywrite.c */
extern
void QbAnywrite P_((Impretc *rc,              /* return code     */
                    const char *ImagePathEnv, /* preappend path  */
                    const char *Filename,     /* output filename */
                    Impvaru *image,           /* image to write  */
                    Impvaru *lut,             /* lookup table to write */
                    QbImageType ImageType,    /* IMG_GREY/IMG_COLOR    */
                    char *ImageDescription    /* Any comments to save  */
                    ));
extern
void QbAnywt24bits P_((Impretc *rc,              /* return code     */
                       const char *ImagePathEnv, /* preappend path  */
                       const char *Filename,     /* output filename */
                       char    *image,           /* image to write  */
                       long xSize, long ySize,   /* image width and height */
                       QbImageType ImageType,    /* IMG_GREY/IMG_COLOR    */
                       char *ImageDescription    /* Any comments to save  */
                      ));
extern
void QbAnywt8bits  P_((Impretc *rc,              /* return code     */
                       const char *ImagePathEnv, /* preappend path  */
                       const char *Filename,     /* output filename */
                       char    *image,           /* image to write  */
                       unsigned char *lut,       /* lookup table to write */
                       long xSize, long ySize,   /* image width and height */
                       QbImageType ImageType,    /* IMG_GREY/IMG_COLOR    */
                       char *ImageDescription    /* Any comments to save  */
                      ));
#undef P_
#endif
