/*
 *  IBM Confidential
 *  
 *  Licensed Materials - Property of IBM
 *
 *  (C) COPYRIGHT IBM Corp. 1994-1998 All rights reserved
 *
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * Filename : QbMac.hpp
 * Date     : 9/14/98 16:25:27
 * Version  : 1.1
 * Author   : Jim Hafner
 * Purpose  : Exposed API's for MacOS tools and utilities
 *
 */

/* End of Common Block                                               */

#ifndef _QBMAC_HPP
#define _QBMAC_HPP

#ifdef __MWERKS__  // just in case we get loaded by some non-mac world 

#include "QbMacDefs.h"
#include <StandardFile.h>
#include <Files.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

/* this defines the maximum number of volumes we can see on a given 
   system at runtime */	
#define MAC_MAX_VOLUMES 50

/* these define the maximum number of "command line" arguments 
   and the max length of each -- we make the options long
   because we may get a long path for -e options */
#define MAC_MAX_ARGS 25
#define MAC_MAX_ARG_LENGTH 1024 

#define MAC_FATAL_ERROR 1
#define MAC_NO_ERROR 0

typedef char argvtype[MAC_MAX_ARGS][MAC_MAX_ARG_LENGTH];

/* these are the exposed data structures */
extern int volCnt;
extern char volNames[MAC_MAX_VOLUMES][32];
extern short bootVRefNum;
extern long prefDirID;
extern FSSpec QbicFolderSpec;
extern long QbicFolderDirID;

/* these are the exposed API's */
extern FILE *QbMacFSp_fopen(const FSSpec *spec);

extern int QbMacInitialize(void);
extern void QbMacShutdown(int err);

extern int QbMacInitQbicPreferences(void);
extern void QbMacGetVolumeNames(void);
extern Boolean QbMacIsVolumeName(const char *volname);
extern Boolean QbMacIsAbsoluteFilename(const char *filename);

#endif /* __MWERKS__ */
#endif /* _QBMAC_HPP */
