/*
 *  IBM Confidential
 *  
 *  Licensed Materials - Property of IBM
 *
 *  (C) COPYRIGHT IBM Corp. 1994-1998 All rights reserved
 *
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * Filename : QbMacDefs.h
 * Date     : 9/14/98 16:25:03
 * Version  : 1.1
 * Author   : Jim Hafner
 * Purpose  : Global defines for building QbicAPI and mains on MacOS.
 *            These take the place of Makefile DEFINES and -D options
 *            that might be used on the "make" command line.  This
 *            could be turned into a "precompiled" header for CodeWarrior
 *            but I think this gets included in all the places where it
 *            is needed automatically.
 *
 */

/* End of Common Block                                               */
/* global mac header defs (what ought to be in Makefile) */
#ifndef _QBMACDEFS_H
#define _QBMACDEFS_H
/* noop if we're not in the right envirnment */
#ifdef __MWERKS__ 

/*****  configurable stuff *****/
/* use this to add in INDEX code and DISTTABLE code */
//#define DO_EXTRAS 


/*****  END configurable stuff *****/

/* these are not really used anywhere but we include them for consistency */
#ifndef DMB_MAC
#define DMB_MAC
#endif

/* these are for Qbic.h and dmbsystm.h */
#define NO_X11
#define NO_DB2

/* these are for the general build choices */
#define _POSIX_SOURCE
#define GENIMAGE

/* these are if we want to add in the extra stuff */
#ifdef DO_EXTRAS
#define INDEX_CODE
#define DISTTABLE_CODE
#endif

#endif /* __MWERKS__ */
#endif /* _QBMACDEFS_H */


