/*
 *  
 *  Licensed Materials - Property of IBM
 *
 *  (C) COPYRIGHT IBM Corp. 1994-1998 All rights reserved
 *
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * Filename : 78
 * Date     : 10/16/98 12:53:11
 * Version  : 1.4.4.1
 * Author   : Denis Lee
 * Purpose  : High level client side QBIC function specification
 *            for query submission and evaluation
 *
 *
 */

/* End of Common Block                                               */

#ifndef __QbQueryC_hpp
#define __QbQueryC_hpp
#include "QbAbsCls.hpp"
class QbQueryClientClass : public QbQueryClass {
public:
//
// This is a OQS style query evaluator
//
// Query specifications should be created using the function
// QbBuildQueryString.  An outline of the format is below however,
// users should ALWAYS use QbBuildQueryString.
//
//  query resultNumber catalogName
//  [[\[ restrictionList \]] [& p ( \[ partOfRestrictionList \] )]]
//  {
//    [ [&]     \[ featureClassname parameters genericData \]
//    [ [&] p ( \[ featureClassname parameters genericData \]
//    [  &      \[ featureClassname parameters genericData \] ...] ) ] ]
//       ...
//  }
//
// restrictionList = QbKeyDatabaseClass.ToQueryString() result
// genericData = QbGenericDataClass.ToQueryString() result
// parameters = QbParameterClass.ToQueryString() result
//
// This result of the query is in the returned QbKeyDatabaseClass
//
  virtual DMBEXPHP (QbKeyDatabaseClass *) Evaluate(const char *querySpecification);
 
  QbQueryClientClass() {} ;
  virtual ~QbQueryClientClass() {} ;
 
  // from QbBaseClass
  virtual const QbInterfaceType IType() const
  { return QueryInterfaceType ; }
  virtual const char *Type() const { return "QbQueryClientClass" ; }
};
//
// routine to read until all bytes needed are obtained
//
extern unsigned long QbSocketRead(int socket,
                                  unsigned char *buffer,
                                  unsigned long neededBytes) ;
#endif
