/*
 *  
 *  Licensed Materials - Property of IBM
 *
 *  (C) COPYRIGHT IBM Corp. 1994-1998 All rights reserved
 *
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * Filename : 62
 * Date     : 3/24/98 09:59:37
 * Version  : 1.3
 * Author   : X. Zhu
 * Purpose  : encapsulate the socket calls for x-platform compatibility
 *
 *
 */

/* End of Common Block                                               */

#ifndef __QbSock_h
#define __QbSock_h
#include <sys/types.h>
#include <dmbsystm.h>
typedef unsigned char   u_char;
typedef unsigned short  u_short;
typedef unsigned long   u_long;
typedef unsigned int    u_int;
#if defined(OS2)
typedef char sendchar ;
#else
typedef const char sendchar ;
#endif
#if defined (WIN32)
  #include <winsock.h>
#elif defined (OS2)
  #include <sys/socket.h>
  #include <netdb.h>
  #include <netinet/in.h>
  #include <utils.h>
#else
  #include <unistd.h>
  #include <sys/socket.h>
  #include <netdb.h>
  #include <netinet/in.h>
  #include <arpa/inet.h>
#endif
extern DMBEXPHP (int)            QbInitSocket(void);
extern DMBEXPHP (void)           QbCleanSocket(void);
extern DMBEXPHP (int)            QbCloseSocket(int socket);
extern DMBEXPHP (unsigned long)  QbSendSocket(   int socket,
                                      char *buf,
                                      unsigned long neededBytes);
extern DMBEXPHP (unsigned long)  QbRecvSocket(   int socket,
                                      char *buf,
                                      unsigned long neededBytes);
#endif
