/* static char sccsid[] = "@(#) File: 01   Version: 1.15   Changed: 95/12/01-13:20:39"; */
/******************************************************************************/
/* dmbsystm.h                                                                 */
/*                                                                            */
/*   This header file is included at the beginning of all DMB header files    */
/*   to define the portibility linkage/export macros for the header file      */
/*   prototypes.                                                              */
/*                                                                            */
/*   DMBEXPF(X) is used to declare/define a function that is exported and     */
/*              has the correct system linkage.                               */
/*                                                                            */
/*   DMBEXPD(X) is used to declare/define a variable that is exported and     */
/*              has the correct system linkage.                               */
/*                                                                            */
/*   DMBMAIN(X) is used to define the correct system linkage for the main()   */
/*              function of a program.                                        */
/*                                                                            */
/* Who  Name                                                                  */
/* ---  ----                                                                  */
/* JLK  James Keesey                                                          */
/*                                                                            */
/*   Date   Who Description                                                   */
/* -------- --- -----------                                                   */
/* 95/10/18 JLK Created                                                       */
/* 96/01/10 EK  modified WNT settings                                         */
/* 96/07/03 Xiaoming Zhu added WIN32 and STATIC settings                      */
/* 96/10/24 Xiaoming Zhu redefined                                            */
/*           DMBEXPHCONSTRUCT, DMBEXPHMEMBER                                  */
/*           DMBEXPCCONSTRUCT, DMBEXPCMEMBER                                  */
/*          in _MSC_VER to allow dll to be built with MS Visual C++           */
/*                                                                            */
/* 97/07/11 Myron Flickner - make the qbic api engine not use sqlsystm.h      */
/*                                                                            */
/******************************************************************************/
#ifndef DMBSYSTMH
#define DMBSYSTMH
/* don't do DB2 stuff for Mac -- note: CodeWarrior did not seem to
   support the #error directive so that is ifndef'ed out below */
#ifdef __MWERKS__
#define NO_DB2
#endif

#ifndef NO_DB2
#include <sqlsystm.h>
#else
#define SQL_API_FN
#endif

/* Temporary */
#if !defined(Export)
#define Export
#endif

#define DMBEXPHD                                        DMBEXPHDATA
#define DMBEXPCD                                        DMBEXPCDATA
#define DMBEXPHP                                        DMBEXPHMEMBER
#define DMBEXPCP                                        DMBEXPCMEMBER
#define DMBEXPHF                                        DMBEXPHCFUNC
#define DMBEXPCF                                        DMBEXPCCFUNC

/******************************************************************************/
/*                                                                            */
/* Macros based on a specific compiler.                                       */
/*                                                                            */
/******************************************************************************/
/*--------------------------------------------------------------------CSet++--*/
#if defined(__xlC__) || defined(_AIX32) || defined(__GNUC__) || defined(STATIC) || defined(DMB_HP) || defined(DMB_SUN) || defined(DMB_SGI)
#define DMB_COMP_CSET

#define DMBEXPHCLASS(C)         C
#define DMBEXPHCONSTRUCT
#define DMBEXPHCFUNC(X)         X SQL_API_FN
#define DMBEXPHCPPFUNC(X)               X
#define DMBEXPHMEMBER(X)                X
#define DMBEXPHDATA(X)                  X

#define DMBEXPCCLASS(C)         C
#define DMBEXPCCONSTRUCT
#define DMBEXPCCFUNC(X)         X SQL_API_FN
#define DMBEXPCCPPFUNC(X)               X
#define DMBEXPCMEMBER(X)                X
#define DMBEXPCDATA(X)                  X

#define DMBMAIN(X)                              X SQL_API_FN

/*----------------For building qbic etc. without DB2 SQLSYSTM.h effect-------*/
/* This define is for qbtcl linked with db2 and dbm for dll                */
/* In this case, dbm should not be affected by db2's SQLSYSTM which        */
/* defines SQL_API_FN as __stdcall linkage on NT with VC++.                */
/*                                                                         */
/* In this case:                                                           */
/* Qbicapi should build with NO_DB2 defined but NO_DB2SQL NOT defined      */
/* DBM     should build with NO_DB2SQL defined            ^^^              */
/* qbtcl   should build with NO_DB2SQL defined                             */
/*                                                                         */
/* Xiaoming Zhu                                                            */

#elif defined(NO_DB2SQL)
#define DMB_COMP_NODB2SQL

#define DMBEXPHCLASS(C)         C
#define DMBEXPHCONSTRUCT
#define DMBEXPHCFUNC(X)         X
#define DMBEXPHCPPFUNC(X)       X
#define DMBEXPHMEMBER(X)        X
#define DMBEXPHDATA(X)          X

#define DMBEXPCCLASS(C)         C
#define DMBEXPCCONSTRUCT
#define DMBEXPCCFUNC(X)         X
#define DMBEXPCCPPFUNC(X)       X
#define DMBEXPCMEMBER(X)        X
#define DMBEXPCDATA(X)          X

#define DMBMAIN(X)              X

/*----------------------------C/C++ for MVS/ESA--or--OS/390 R2 C/C++ feature--*/
/* use of sql_api_fn seems questionable - its not for everyone */
#elif defined(DMB_MVS)
#define DMB_COMP_IBMC

#define DMBEXPHCLASS(C)         C
#define DMBEXPHCONSTRUCT
#define DMBEXPHCFUNC(X)         X SQL_API_FN
#define DMBEXPHCPPFUNC(X)               X
#define DMBEXPHMEMBER(X)                X
#define DMBEXPHDATA(X)                  X

#define DMBEXPCCLASS(C)         C
#define DMBEXPCCONSTRUCT
#define DMBEXPCCFUNC(X)         X SQL_API_FN
#define DMBEXPCCPPFUNC(X)               X
#define DMBEXPCMEMBER(X)                X
#define DMBEXPCDATA(X)                  X

#define DMBMAIN(X)                              X

/*---------------------------------------------------Microsoft Visual C++ 1.5-*/
#elif defined(DMB_WIN)
#define DMB_COMP_MSC

#define DMBEXPHCLASS(C)         __export C
#define DMBEXPHCONSTRUCT
#define DMBEXPHCFUNC(X)         X __export SQL_API_FN
#define DMBEXPHCPPFUNC(X)       X __export
#define DMBEXPHMEMBER(X)        X
#define DMBEXPHDATA(X)          X __export

#define DMBEXPCCLASS(C)         __export C
#define DMBEXPCCONSTRUCT
#define DMBEXPCCFUNC(X)         X __export SQL_API_FN
#define DMBEXPCCPPFUNC(X)       X __export
#define DMBEXPCMEMBER(X)        X
#define DMBEXPCDATA(X)          X __export

#define DMBMAIN(X)                      X _cdecl

/*------------------------------------------------------Microsoft Visual C++--*/
#elif defined(_MSC_VER)
#define DMB_COMP_MSC

#define DMBEXPHCLASS(C)         C __declspec(dllexport)
#define DMBEXPHCONSTRUCT          __declspec(dllexport)
#define DMBEXPHCFUNC(X)         __declspec(dllexport) X SQL_API_FN
#define DMBEXPHCPPFUNC(X)               __declspec(dllexport) X
#define DMBEXPHMEMBER(X)                __declspec(dllexport) X
#define DMBEXPHDATA(X)                  __declspec(dllimport) X

#define DMBEXPCCLASS(C)         C __declspec(dllexport)
#define DMBEXPCCONSTRUCT        __declspec(dllexport)
#define DMBEXPCCFUNC(X)         __declspec(dllexport) X SQL_API_FN
#define DMBEXPCCPPFUNC(X)               __declspec(dllexport) X
#define DMBEXPCMEMBER(X)                __declspec(dllexport) X
#define DMBEXPCDATA(X)                  __declspec(dllexport) X

#define DMBMAIN(X)                              X _cdecl
/*-------------------------------------------------------------VisualAge C++--*/
#elif defined(DMB_OS2) || defined(DMB_WNT)
#define DMB_COMP_VAC

#define DMBEXPHCLASS(C)         C
#define DMBEXPHCONSTRUCT
#define DMBEXPHCFUNC(X)         X SQL_API_FN
#define DMBEXPHCPPFUNC(X)               X
#define DMBEXPHMEMBER(X)                X
#ifdef DMB_WNT
#define DMBEXPHDATA(X)                  X _Import
#else
#define DMBEXPHDATA(X)                  X
#endif

#define DMBEXPCCLASS(C)         C _Export
#define DMBEXPCCONSTRUCT     _Export
#define DMBEXPCCFUNC(X)         X _Export SQL_API_FN
#define DMBEXPCCPPFUNC(X)               X _Export
#define DMBEXPCMEMBER(X)                X _Export
#define DMBEXPCDATA(X)                  X _Export

#define DMBMAIN(X)                              X
/*--------------------------------------------------------------Symantec C++--*/
#elif defined(__SC__)
#define DMB_COMP_SC

#define DMBEXPHCLASS(C)         C
#define DMBEXPHCONSTRUCT
#define DMBEXPHCFUNC(X)         X SQL_API_FN
#define DMBEXPHCPPFUNC(X)               X
#define DMBEXPHMEMBER(X)                X
#define DMBEXPHDATA(X)                  X

#define DMBEXPCCLASS(C)         C
#define DMBEXPCCONSTRUCT
#define DMBEXPCCFUNC(X)         X SQL_API_FN
#define DMBEXPCCPPFUNC(X)               X
#define DMBEXPCMEMBER(X)                X
#define DMBEXPCDATA(X)                  X

#define DMBMAIN(X)                              X
/*-----------------------------------------------------------MetroWorks Codewarrior or Mac-*/
#elif defined(__MWERKS__)
#define DMB_MAC

#define DMBEXPHCLASS(C)         C
#define DMBEXPHCONSTRUCT
#define DMBEXPHCFUNC(X)         extern X
#define DMBEXPHCPPFUNC(X)       X
#define DMBEXPHMEMBER(X)        X
#define DMBEXPHDATA(X)          X

#define DMBEXPCCLASS(C)         C
#define DMBEXPCCONSTRUCT
#define DMBEXPCCFUNC(X)         X
#define DMBEXPCCPPFUNC(X)       X
#define DMBEXPCMEMBER(X)        X
#define DMBEXPCDATA(X)          X

#define DMBMAIN(X)              X

/*-------------------------------------------------------------------Unknown--*/
#else
#ifndef __MWERKS__
#error "DMB: Unsupported Compiler."
#endif
#endif
/*----------------------------------------------------------------------------*/

/******************************************************************************/
/*                                                                            */
/* Macros based on a specific operating system.                               */
/*                                                                            */
/******************************************************************************/
/*-----------------------------------------------------------------AIX--------*/
#if defined(DMB_UNIX)

#define DMB_PATH_SEP            '/'
#define MaxPathName                     1000


/*-----------------------------------------------------------------OS/2-------*/
#elif defined(DMB_OS2)
#define DMB_PATH_SEP            '\\'
#define MaxPathName                     260

/*---------------------------------------------------------------Windows 3.1--*/
#elif defined(DMB_WINDOWS)

#define DMB_PATH_SEP            '\\'
#define MaxPathName                     1000

/*-----------------------------------------------------------------MacOs------*/
#elif defined(DMB_MAC)

#define DMB_PATH_SEP            ':'
#define MaxPathName                     1000

/*-----------------------------------------------------------------Unknown----*/
#else
#ifndef __MWERKS__
#error "DMB: Unsupported Operating System"
#endif
#endif
/*----------------------------------------------------------------------------*/

#endif
