@echo off
@REM echo "+-------------------------------------------------------------+"
@REM echo "| This command file helps you                                 |"
@REM echo "| 1. Create the thumbnail images in    qbic\html\thumb\       |"
@REM echo "| 2. Create the Qbic image database in qbic\QbicData\         |"
@REM echo "|-------------------------------------------------------------|"

@REM -- set to root of Qbic Tree, add a drive letter if needed ---
SET QBICBASE=\usr\local\qbic

@REM -- point to dll's ---
SET BEGINLIBPATH=%QBICBASE%\bin
SET QBICPATH=%QBICBASE%\bin

if "%1" == "help" goto help
if "%1" == "Help" goto help
if "%1" == "HELP" goto help
if "%1" == "-h" goto help
if "%1" == "/h" goto help
if "%1" == "-H" goto help
if "%1" == "/H" goto help
if "%1" == "?" goto help

if "%1" == "java" goto java
if "%1" == "Java" goto java
if "%1" == "JAVA" goto java

if "%1" == "" set CAT=ibm
if not %1 == "" set CAT=%1

@echo Creating image database %CAT%

SET QbicDatabaseName=%QBICBASE%\QbicData
SET QbicImagePath=%QBICBASE%\html\images\%CAT%
SET QbicTextPath=%QBICBASE%\html\text\%CAT%
SET QbicThumbPath=%QBICBASE%\html\thumb\%CAT%

rem  build the thumbnail directory
if exist %QbicThumbPath% goto buildthumbnails
@echo Building the thumbnail directory %QbicThumbPath%
mkdir %QbicThumbPath%

:buildthumbnails:

cd %QbicImagePath%
@echo Creating thumbnail images, please wait ...

for %%f in (*.*) do %QBICPATH%\QbMkThmb %%f %QbicThumbPath%\%%f.thumb0.gif

@echo Initializing the catalog database files
%QBICPATH%\QbMkDbs -c %CAT% -d %QbicDatabaseName% -f QbColorFeatureClass -f QbTextureFeatureClass -f QbColorHistogramFeatureClass -f QbDrawFeatureClass -f QbTextFeatureClass 

@echo Building list of images to catalog
dir /b *.jpg *.gif *.tif *.bmp > image.list 2>NUL
@echo Computing features for all images, please wait ...
%QBICPATH%\QbMkDbs -c %CAT% -d %QbicDatabaseName% -l image.list
erase image.list 2>NUL

goto done

:java
if "%2" == "" set CAT=ibm
if not "%2" == "" set CAT=%2

@echo Starting Java Catalog Creation
set CLASSPATH=%QBICBASE%\classes;%CLASSPATH%
@REM start java application 
java QbJavaMkCat %QBICBASE%\Config\%CAT%.mkcat.cfg

goto done


:help
@echo Usage:
@echo   "QbCreateCat [help | ? | /h | -h] [Java] [CatName]"
@echo Options:
@echo   NO OPTIONS -- Builds the sample ibm image catalog as batch program.
@echo   help       -- This and friends dump this usage message.
@echo   [Java]     -- Starts the Java application user interface for creating
@echo                 a catalog.  Without CatName, initializes the ibm catalog.
@echo                 With CatName specified, searchs for CatName.mkcat.cfg
@echo                 in the qbic/Config directory to initialize fields.
@echo   [CatName]  -- Builds a catalog with the given name as batch program.


:done
cd %QBICBASE%\bin
