#!/usr/local/qbic/bin/tclsh

### (C) COPYRIGHT International Business Machines Corp. 1997
### Author: Xiaoming Zhu (xzhu@almaden.ibm.com)
###########################################################################
# configuration / setup
# 
# CHANGE THIS FIRST SECTION FOR YOUR DEMO 
# It has two parts, the first for population, and the second for web cgi
# mapping.
###########################################################################
## playing sound on PC based machine
global tcl_platform env
if [info exists env(sound)] {
  if { $tcl_platform(platform) == "windows" && $env(sound) == 0 } {
     catch {SoundPlay ../../sound/qbegin.wav}
     set env(sound) 1
  }
}

## Please replace stock by whatever catalog name you want to use here.  
set catalog ibm33
set urlpage $catalog.tcl

###########################################################################
# The following section is for populating qbic database, you do not need
# to worry the section if you want to use this script as cgi
# to make sure qbic population result can be used in cgi we assume
# you have mapped
#
# d:/usr/local/qbic/html         document root directory
# d:/usr/local/qbic/html/images  /image
# d:/usr/local/qbic/html/thumb   /thumb
# d:/usr/local/qbic/html/classes /classes 
#
###########################################################################
set root D:/qbic/qbic

if { [file pathtype $root] != "relative" && 
      $tcl_platform(platform) == "macintosh" } {
   set tmp "/"
   append tmp $root
   set root $tmp
}

set paths(root)       $root
set paths(image_root) $root/html/images/$catalog
set paths(qbic_db)    $root/QbicData
set paths(keys_db)    $paths(qbic_db)/keys.$catalog
set paths(qbic_bin)   $root/bin
set paths(thumbnails) $root/html/thumb/$catalog
set paths(text)       $root/html/text/$catalog

set params(qbic_catalog) $catalog
set params(image_re) {^.*\.(gif|jpg|jpeg|bmp|tif|tiff)$}
set params(clean) "yes"

if { $tcl_platform(platform) == "macintosh" &&
     [string range $paths(image_root) 0 0] == "/"} {
    set env(QbicImagePath) [string range $paths(image_root) 1 end]
} else {
    set env(QbicImagePath) $paths(image_root)
}
if { $tcl_platform(platform) == "macintosh" &&
     [string range $paths(text) 0 0] == "/"} {
    set env(QbicTextPath) [string range $paths(text) 1 end]
} else {
    set env(QbicTextPath) $paths(text)
}

###########################################################################
# The following section is for setting up cgi script to put qbic on web
# you do not need to worry the section if you just use the script to
# populate qbic database
###########################################################################

## the URL for this script (self-referenence)
set urls(script) "/cgi-bin/$urlpage"

## the name of the catalog -- assuming you conform to the recommended
## directory structure (qbic/html/[images,text,thumb]/$params(qbic_catalog))
set params(qbic_catalog) $catalog

## the suffix for thumbnails for this catalog
set urls(thumbnail_suffix) .thumb0.jpg

## a string to acknowledge source of the images 
set params(courtesy) "<a href=/> QBIC Front Page</a>"
##"Images courtesy of <a href=\"http://www.template-demo.qbtcl/\"> TemplateImages, Inc.</a>"

## the feature classes you want to enable (should always include QbInfo)!
## put them in the order you want them arranged  
##set params(qbefeatures) {{QbInfo} {QbColorHistogramFeatureClass} {QbDrawFeatureClass} {QbEdgeHistogramFeatureClass} {QbHistogramLayoutFeatureClass} {QbDrawEnhancedFeatureClass} {QbColorEnhancedHistogramFeatureClass} {QbEnhColorFeatureClass} }
set params(qbefeatures) {{QbInfo} {QbColorHistogramFeatureClass} {QbDrawFeatureClass} {QbTextureFeatureClass} {QbTextFeatureClass} }

## set this to anything, if you have QbTextureFeatureClass enabled
set params(text) "Enabled"
###########################################################################
# process the common template html, procs and variables 
#  --  this MUST be here --
###########################################################################
if [info exists env(QBTCL_LIB)] {
   if { $tcl_platform(platform) == "macintosh" } {
      source $env(QBTCL_LIB):qbicmain-common-demo.tcl
   } else {
      source $env(QBTCL_LIB)/qbicmain-common-demo.tcl
   }
} else {
   set env(QBTCL_LIB) "$root/script"
   if { $tcl_platform(platform) == "macintosh" } {
      if { [string range $root 0 0] == "/"} {
          set env(QBTCL_LIB) "[string range $root 1 end]:script"
      } else {
               set env(QBTCL_LIB) "$root:script"
      }    
      source $env(QBTCL_LIB):qbicmain-common-demo.tcl
   } else {
      set env(QBTCL_LIB) "$root/script"
      source $env(QBTCL_LIB)/qbicmain-common-demo.tcl
   }
}

### END OF PARAMETERS ###
### DON'T REMOVE THE PREVIOUS LINE ###

###########################################################################
# ADD user customizations here 
#  -- override any method/variable/whatever in qbic-common-demo.tcl
#  -- add anything you want special
###########################################################################

###########################################################################

# permanent overrides
set urls(image_prefix)    /images/$catalog/
set urls(thumbnail_prefix) /thumb/$catalog/

set params(qbefeatures) {                                       \
                         {QbInfo}                               \
                         {QbColorHistogramFeatureClass}         \
                         {QbDrawFeatureClass}                   \
                         {QbTextureFeatureClass}                \
                         {QbHybridColorFeatureClass}            \
                         }


set iconhelp(QbColorHistogramFeatureClass) "Color Histogram"
set iconhelp(QbDrawFeatureClass)           "Layout"
set iconhelp(QbTextureFeatureClass)        "Texture"

set type(QbHybridColorFeatureClass) "QbHybridColorFeatureClass"
set icon(QbHybridColorFeatureClass) "letterS.gif"
set fname(QbHybridColorFeatureClass) "HybridColor"
set pickerpage(QbHybridColorFeatureClass) ""
set iconhelp(QbHybridColorFeatureClass) "Special Hybrid"
set feature(HybridColor) "QbHybridColorFeatureClass"                           
set params(qbic_maxresults) 200

### Local Variables: ***
### mode: tcl ***
### End: ***

###########################################################################
#execute the command script
runquery                                                                       

