#!/usr/local/qbic/bin/tclsh

### (C) COPYRIGHT International Business Machines Corp. 1998
### Author: Xiaoming Zhu (xzhu@almaden.ibm.com)
###########################################################################

#set qbicimage "/usr/local/qbic/html/images"
set noindex 0

#
# macintosh needs special attention
#
proc FixMacPath {mixedPath} {
    global currentDIR tcl_platform

    if { $tcl_platform(platform) != "macintosh" } {
        return $mixedPath
    }
    regsub $currentDIR $mixedPath {} relPath
    regsub -all "/" $relPath {:} fixed
    set fixedPath $currentDIR
    append fixedPath $fixed
    return $fixedPath
}

proc runindex {} {
     global env imagePage qbicimage Httpd

     set options $env(PATH_INFO)
     regexp {/([^/]*)/} $options match keyword
     if {![string compare $keyword "create"]} {
        regsub "/$keyword" $options {} qbicimage
        set result [indexHeader $qbicimage]
        return $result
     } elseif {![string compare $keyword "home"]} {
        set result [qbicFrontPage $Httpd(root)/html/images]
        return $result
     } elseif {![string compare $keyword "usage"]} {
        set result [qbicUsagePage $Httpd(root)/html/images]
        return $result
     } elseif {![string compare $keyword "frontPage"]} {
        regsub "/$keyword" $options {} qbicimage
        if {[regexp "^/.:*" $qbicimage]} {
           set qbicimage [string range $qbicimage 1 end]
        }
        set result [qbicFrontPage $qbicimage]
        return $result
     } elseif {![string compare $keyword "demo"]} {
        regsub "/$keyword" $options {} qbicimage
        if {[regexp "^/.:*" $qbicimage]} {
           set qbicimage [string range $qbicimage 1 end]
        }
        set result [qbicDemoPage $qbicimage]
        return $result
     } elseif {![string compare $keyword "index"]} {
        regsub "$match" $options {} catalog
        set result [indexWarn $catalog]
        return $result
     } elseif {![string compare $keyword "yes"]} {
        regsub "$match" $options {} catalog
        set result [indexCat $catalog]
        return $result
     }
}

proc qbicFrontPage {qbicimage} {
   global noindex
   set msg "<CENTER><IMG SRC=/gifs/masthead.gif></CENTER>
            <BODY BGCOLOR=#EEE3D1 TEXT=black link=blue alink=red 
                 vlink=purple>
            <br>

            <HR>
            <CENTER><H2> QBIC<sup><small>(TM)</small></sup> -- 
                             IBM's Query By Image Content </H2></CENTER>
            <table>
            <tr>
            <bf> Goto: </bf> <br>
            <td width=320 valign=top> 
            <a href=/cgi-bin/qbicindex.tcl/usage/$qbicimage>
                  How to Use QBIC </a> <br><p>
            <a href=/docs/HtmlDoc/Text/index.htm>
                  QBIC Programmer's Guide </a> <br><p>
            "
   if {$noindex == 1} {
      append msg "
            <a href=/cgi-bin/ibm.tcl> IBM Image Search Demo </a> <br><p>
            "
          
   } else {
      append msg "
            <a href=/cgi-bin/qbicindex.tcl/demo/$qbicimage>
                  QBIC Search</a><br><p>
            <a href=/cgi-bin/qbicindex.tcl/create/$qbicimage>
                  Create New Qbic Catalog </a> <br><p>
            "
   }
   append msg "
            <a href=/httpstop> Stop QBIC Http Server</a> <br><p>
            <br>
            <a href=http://wwwqbic.almaden.ibm.com> Official QBIC Page</a>
            </td>
            <td>
	     QBIC allows you to make queries of image databases large and
             small based on visual characteristics -- properties such as
             color percentages, color layout and textures occurring in the
             images.  The
             queries match image colors, textures and their positions without 
	     having to describe them with in words.  QBIC's content-based 
	     queries can also be combined with keywords to provide a 
	     powerful multimedia search and retrieval tool. As image
             collections grow larger and become more prolific, QBIC is the
             best tool to more efficiently search and navigate through them.  
             <br> <br>
             "

   if {$noindex == 1} {
      append msg "
             In this <a href=/cgi-bin/ibm.tcl> demo </a>, we use QBIC to
             index about 470 color images based
             on their color and texture information.  You can evaluate the
             QBIC Search capability by following the link located at left
             called IBM Image Search Demo. <br> <br>
             For license and business related questins, please contact Ted
             Loewenberg by phone 408-927-1202, or by email
             tedl@almaden.ibm.com.  For technical questions, please contact
             Xiaoming Zhu by phone 408-927-1427 or by email
             xzhu@almaden.ibm.com.
      "
   } else {
      append msg "
             In this <a href=/cgi-bin/ibm33.tcl> release </a>, we include
             33 color images so that you can used them to populate and
             query a QBIC database to evaluate the QBIC functionality. <br><br>
             For license and business related questins, please contact Ted
             Loewenberg by phone 408-927-1202, or by email
             tedl@almaden.ibm.com.  For technical questions, please contact
             Xiaoming Zhu by phone 408-927-1427 or by email
             xzhu@almaden.ibm.com.
      "
   }
   append msg "
            </td>
            </tr>
            </table>
            </b>
            </html>"
   return $msg
}

proc qbicUsagePage {qbicimage} {
   global noindex
   set msg "<CENTER><IMG SRC=/gifs/masthead.gif></CENTER>
            <BODY BGCOLOR=#EEE3D1 TEXT=black link=blue alink=red 
                 vlink=purple>
            <br>

            <HR>
            <CENTER><H2> QBIC<sup><small>(TM)</small></sup> -- 
                             IBM's Query By Image Content </H2></CENTER>
            <table>
            <tr>
            <bf> Goto: </bf> <br>
            <td width=320 valign=top> 
            <a href=/docs/HtmlDoc/Text/index.htm>
                  QBIC Programmer's Guide </a> <br><p>
            <a href=/cgi-bin/qbicindex.tcl/demo/$qbicimage>QBIC Search
                 </a><br><p>
            "
    if { $noindex == 0 } {
       append msg "
            <a href=/cgi-bin/qbicindex.tcl/create/$qbicimage>
                  Create New QBIC Catalog </a> <br> <p>
            "
    }
    append msg "
            <a href=/httpstop> Stop QBIC Http Server</a><br><p>
            <a href=/> QBIC Front Page </a> <br> <p>
            <br>
            <a href=http://wwwqbic.almaden.ibm.com> Official QBIC Page</a>
            </td>
            <td>
             <H2> Brief Instructions on Using QBIC Demo: </H2>
             In QBIC demo start page, you are presented with a set of randomly
             selected images.  Small Icons such as <img src=/gifs/letterC.gif>
             allow you to choose a different QBIC feature to search for images.
             <ul>
             <li> click <img src=/gifs/letterI.gif> to view the full image.
             <li> click <img src=/gifs/letterC.gif> to search images with
              similar color percentage.
             <li> click <img src=/gifs/letterL.gif> to search images with
              similar color layout (sensitive to color position).
             <li> click <img src=/gifs/letterT.gif> to search images with
              similar global texture.
             <li> click <img src=/gifs/letterS.gif> to search images with
              special multipass filter (similar to color layout).
             
             </ul>

             If the images contain keyword information, you can search the
             images with keyword, too.  Enter any keyword in the keyword entry
             box located at the top of the image displaying area.  If you
             simply hit return after entering a keyword, QBIC will present you
             a set of randomly selected images which contain the keyword
             you entered.  If you hit any Icon after entering a keyword, QBIC
             will search the images based on the feature the Icon corresponds
             to and on the keyword you entered.  Keyword search is great to
             constrain your search domain.  But if you want to see all images
             with certain QBIC feature, don't forget to remove any keyword
             in the box.  In this demo CD, you can try keywords such as
             <font color=red> France, flower, beach, </font> etc.
            </td>
            </tr>
            </table>
            </b>
            </html>"
     return $msg
}

proc indexWarn {catalog} {
     global imagePage
     set msg "
            <table>
            <tr>
            <td width=160 valign=top> 
            <a href=/cgi-bin/qbicindex.tcl/usage/$imagePage>
                  How to Use QBIC </a> <br><p>
            <a href=/docs/HtmlDoc/Text/index.htm>
                  QBIC Programmer's Guide </a> <br><p>
            <a href=/cgi-bin/qbicindex.tcl/demo/$imagePage> 
                  IBM QBIC Search </a> <br> <p>
            <a href=/cgi-bin/qbicindex.tcl/create/$imagePage>
                  Create New QBIC Catalog </a> <br> <p>
            <a href=/httpstop> Stop QBIC Http Server</a> <br> <p>
            <a href=/> QBIC Front Page </a> <br> <p>
            <br>
            <a href=http://wwwqbic.almaden.ibm.com> Official QBIC Page</a>
            </td>
            <td valign=top>
            <img src=/gifs/sp.gif width=0 height=0> <br clear=both>
            <img src=/gifs/black.gif width=1 height=160>
            </td>
            <td valign=top>
              You choose to index/reindex catalog <code> $catalog</code>:
              this may take long!<br>
              Please confirm your choice by push the YES button.  If you
              choose yes, the existing QBIC catalog named
              <code> $catalog </code> will be deleted and then recreated.
              This is your last chance to change your mind.  If you DO
              want to change your mind, press NO or go to other pages.
              <br>
              <form action=/cgi-bin/qbicindex.tcl/yes/$catalog>
              Are you sure you want to index QBIC catalog $catalog? <br>
              <input type=\"submit\" value=\"Yes\">
              </form>
              <form action=/cgi-bin/qbicindex.tcl/create/$imagePage>
              <input type=\"submit\" value=\"No\">
              </form>
            </td>
            </tr>
            </table>
            "
     return $msg
}

proc indexCat {catalog} {
     global imagePage paths params tcl_platform noindex
     set currentDIR [pwd]
     if {$tcl_platform(platform) == "macintosh"} {
        regsub -nocase ":html:images" $imagePage {} qbicroot
        cd $qbicroot:script
     } else {
        regsub -nocase "/html/images" $imagePage {} qbicroot
        cd $qbicroot/script
     }
     if {[catch {set fd [open "template.tcl" r]}]} {
        puts stderr "can't find $template.tcl file to open"
        cd $currentDIR
        return
     }
     set template [read $fd]
     close $fd
     regsub "CATALOGNAME" $template $catalog template
     regsub "QBICROOT" $template $qbicroot template
     set fd [open $catalog.tcl w]
     puts $fd $template
     close $fd
     source "qbicmain-common-index.tcl"
     set_config $catalog.tcl
     vexist paths(qbic_db) paths(thumbnails) paths(image_root) params(image_re)
     MakeDataBase
     MakeThumb
     cd $currentDIR
     set msg "
            <table>
            <tr>
            <td width=160 valign=top> 
            <a href=/cgi-bin/qbicindex.tcl/usage/$imagePage>
                  How to Use QBIC </a> <br><p>
            <a href=/docs/HtmlDoc/Text/index.htm>
                  QBIC Programmer's Guide </a> <br><p>
            <a href=/cgi-bin/qbicindex.tcl/demo/$imagePage> 
                  IBM QBIC Search </a> <br> <p>
            "
     if { $noindex == 0 } {
        append msg "
            <a href=/cgi-bin/qbicindex.tcl/create/$imagePage>
                  Create New QBIC Catalog </a> <br> <p>
        "
     }
     append msg "
            <a href=/httpstop> Stop QBIC Http Server</a> <br> <p>
            <a href=/> QBIC Front Page </a> <br> <p>
            <br> 
            <a href=http://wwwqbic.almaden.ibm.com> Official QBIC Page</a>
            </td>
            <td valign=top>
            <img src=/gifs/sp.gif width=0 height=0> <br clear=both>
            <img src=/gifs/black.gif width=1 height=50>
            </td>
            <td valign=top>
                Congratulations <a href=/cgi-bin/$catalog.tcl> $catalog </a>
                has been successfully indexed! <b>
            </td>
            </tr>
            </table>
            "
     return $msg
}

proc indexHeader {qbicimage} {
     global imagePage tcl_platform
     if {[regexp "^/.:*" $qbicimage]} {
        set qbicimage [string range $qbicimage 1 end]
     }
     set qbicimage [FixMacPath $qbicimage]
     set imagePage $qbicimage
     set currentDIR [pwd]
     cd $qbicimage
     if {$tcl_platform(platform) != "macintosh"} {
        regsub -nocase "/html/images" $qbicimage "" qbicroot
        set qDir $qbicroot/QbicData
        set iwrite [file writable $qbicroot/QbicData]

     } else {
        regsub -nocase ":html:images" $qbicimage "" qbicroot
        set qDir $qbicroot:QbicData
        set iwrite [file writable $qbicroot:QbicData]
     }
     set dirList {}
     catch {set dirList [glob *]}
     set subList {}
     foreach subDir $dirList {
        if {[file isdirectory $subDir]} {
           lappend subList $subDir
        }
     }

     set idxOption "Currently you can index (reindex) the following "
     append idxOption "QBIC catalog(s): <br>"

     if {[expr [llength $subList] > 0]} {
        foreach subDir $subList {
           append idxOption \
              "<a href=/cgi-bin/qbicindex.tcl/index/$subDir>$subDir</a> <br>"
        }
     } else {
        puts idxOption "Currently you do not have any image subdirectory
            under $qbicimage so you can't index any catalog.  Please follow
            the instructions above and update this page."
     }
     
     set photo $qbicimage/Photo
     if { $tcl_platform(platform) == "macintosh" } {
        set photo $qbicimage:Photo
     }

     if { $iwrite == 1 } {
        set idxMSG "
               To create new QBIC catalog of your own image collection, you
               need to copy your images to a subdirectory under $qbicimage.
               The subdirectory name should be your catalog name.  For example,
               If you want to create a QBIC catalog named Photo, you should
               <ul>
               <li> Create <code> Photo </code> subdirectory in <code>
                    $qbicimage. </code>
               <li> Copy all images to <code> $photo. </code>
               <li> Refresh this page in this browser (Press Reload button.)
               <li> click the link to <code> Photo</code> or any 
                    one of the links below.
               </ul>
               $idxOption
             "
     } else {
        set idxMSG "
               You DO NOT have the write permission for the <code> $qDir
               </code> directory.  Perhaps the drive is mounted read-only
               such as a CD-ROM or you are running the software
               installed by another user.  Please fix the problem before
               come back to this page.
             "
     }
     set msg "
            <table>
            <tr>
            <td width=320 valign=top> 
            <a href=/cgi-bin/qbicindex.tcl/usage/$qbicimage>
                  How to Use QBIC </a> <br><p>
            <a href=/docs/HtmlDoc/Text/index.htm>
                  QBIC Programmer's Guide </a> <br><p>
            <a href=/cgi-bin/qbicindex.tcl/demo/$qbicimage> 
                  IBM QBIC Search </a> <br> <p>
            <a href=/httpstop> Stop QBIC Http Server</a> <br> <p>
            <a href=/> QBIC Front Page </a> <br> <p>
            <br>
            <a href=http://wwwqbic.almaden.ibm.com> Official QBIC Page</a>
            </td>
            <td valign=top>
            <img src=/gifs/sp.gif width=0 height=0> <br clear=both>
            <img src=/gifs/black.gif width=1 height=160>
            </td>
            <td valign=top>
                $idxMSG
            </td>
            </tr>
            </table>
            "
      cd $currentDIR
      return $msg
}

proc qbicDemoPage {qbicimage} {
     global imagePage tcl_platform noindex
     set currentDIR [pwd]
     set qbicimage [FixMacPath $qbicimage]
     if {$tcl_platform(platform) != "macintosh"} {
        regsub -nocase "/html/images" $qbicimage "" qbicroot
        cd $qbicroot/QbicData
     } else {
        regsub -nocase ":html:images" $qbicimage "" qbicroot
        cd $qbicroot:QbicData
     }
     set dirList {}
     if { [catch {set catList [glob FeatIdx.*]}] } {
        puts stderr "no catalog available for demo"
        set demoOption "Currently you do not have any qbic catalog indexed.
            Please <a href=/cgi-bin/qbicindex.tcl/create/$qbicimage>
            Create New Qbic Catalog </a> before you visit this page."
     } else {
        set demoOption    "Currently you have the following qbic catalogs "
        append demoOption "ready for query <br>"

        foreach cat $catList {
           regsub -nocase "FeatIdx\." $cat "" cat
           append demoOption "<a href=/cgi-bin/$cat.tcl> $cat </a><br>"
        }
     }
     
     set msg "
            <table>
            <tr>
            <td width=160 valign=top> 
            <a href=/cgi-bin/qbicindex.tcl/usage/$qbicimage>
                  How to Use QBIC </a> <br><p>
            <a href=/docs/HtmlDoc/Text/index.htm>
                  QBIC Programmer's Guide </a> <br><p>
            "
     if { $noindex == 0 } {
        append msg "
            <a href=/cgi-bin/qbicindex.tcl/create/$qbicimage>
                  Create New QBIC Catalog </a> <br> <P>
            "
     } 
     append msg "
            <a href=/httpstop> Stop QBIC Http Server</a> <br> <P>
            <a href=/> QBIC Front Page </a> <br> <p>
            <br>
            <a href=http://wwwqbic.almaden.ibm.com> Official QBIC Page</a>
            </td>
            <td valign=top>
            <img src=/gifs/sp.gif width=0 height=0> <br clear=both>
            <img src=/gifs/black.gif width=1 height=50>
            </td>
            <td valign=top>
               $demoOption
            </td>
            </tr>
            </table>
            "
      cd $currentDIR
      return $msg
}

runindex
